/**
* \mainpage
* 	This is a small "how to use"-example of an simple implementation of a command-interface
* 	using the internal UART of the AVRMega32 to receive commands from an terminal (e.g. TeraTerm, Hyperterminal)
*
* \section Explanation command-interface
* 	This example creates three commands using the function
*	\li cmd_interface_add_cmd("help",	&command_0);
*	\li cmd_interface_add_cmd("c1",		&command_1);
*	\li cmd_interface_add_cmd("test",	&command_2);
*
* \section Setup Com-Interface
* \li Baudrate:	9600
* \li Databits:	8
* \li Parity:		None
* \li Stopbits:	1
* \li FlowContr.:	none
*
* \section Setup AVRMega M32
*
* \li Clock:		16Mhz
* \li Fuses:		....
*/


/* Standard includes */
#include <stdio.h>
#include <string.h>
/* #include "stdafx.h" */

/*  Projek includes */
#include "string_addon.h"
#include "cmd_interface.h"

//#include "stdint.h"
//#include <ctype.h>
//#include <string.h>

/* Function Prototypes
************************************************/
/* command functions */
uint8_t command_0(int8_t argc, char *argval[]);
uint8_t command_1(int8_t argc, char *argval[]);
uint8_t command_2(int8_t argc, char *argval[]);
uint8_t command_3(int8_t argc, char *argval[]);
uint8_t command_4(int8_t argc, char *argval[]);
uint8_t command_5(int8_t argc, char *argval[]);
uint8_t command_6(int8_t argc, char *argval[]);
uint8_t command_7(int8_t argc, char *argval[]);
uint8_t command_8(int8_t argc, char *argval[]);
uint8_t command_9(int8_t argc, char *argval[]);

/* Defines
************************************************/
#define _terminal_startup_message "\n Ready to receive your commands"

/* Global variables
************************************************/

char str_inp[80] = "";
/* char commands[dCMD_INTERFACE_NO_OF_COMMANDS][20] = { { "help" }, { "cmd_1" }, { "cmd_2" } };
*/
char command0[] = "help";
char command1[] = "cmd_1";
char command2[] = "cmd_2";

/**	*
*	MAIN
*
******************************************************************/

int main(int argc, char* argv[]){
	int8_t i8_tmp = 0;

/* Initialisation */
	cmd_interface_init();
	/* add command-functions to command-interface */
	cmd_interface_add_cmd(command0, &command_0);
	cmd_interface_add_cmd(command1, &command_1);
	cmd_interface_add_cmd(command2, &command_2);

/* Main-Loop*/
	printf(_terminal_startup_message);
	while (1){
		printf("\n\rcmd>");
		do {
			fgets(str_inp, 80, stdin);
			i8_tmp = execute_cmd_interface(&str_inp[0]);
		} while (0 == i8_tmp);
		if (i8_tmp<0) {
			printf("\n\r Error: %x", i8_tmp);
		}
	}
	printf("End des Programms - wenn das kommt ist was schief gelaufen ;)");

	return 0;
} /* int main (void) */



/**	*
*	Command functions
*
******************************************************************/
uint8_t command_0(int8_t argc, char *argval[]){
	printf("\r\n HELP !");
	printf("\r\n help <enter>");
	printf("\r\n     >> this help text");
	return 0;
}

uint8_t command_1(int8_t argc, char *argval[]){
	uint8_t ui8_cnt;
	printf("\n\r...received command cmd_1, with option\n\r");
	for (ui8_cnt = 0; argc>ui8_cnt; ui8_cnt++){
		printf("	%d:%s;\n\r", ui8_cnt, argval[ui8_cnt]);
	}
	return 0;
}

uint8_t command_2(int8_t argc, char *argval[]){
	uint8_t ui8_cnt;
	printf("\n\r...received command cmd_2, with options\n\r");
	for (ui8_cnt = 0; argc>ui8_cnt; ui8_cnt++){
		printf("	%d:%s;\n\r", ui8_cnt, argval[ui8_cnt]);
	}
	return 0;
}





