/***************************************************************************/
/**
	\file		string_addon.h
	\brief		some additional clever string functions
	\author		Gerhard Bruenner
	\version	V0.16

	\addtogroup grStr String Ops.
	\section secCo Compiler
	    Tested at: GCC(WinAVR)

	\section secSW New functions
	    - ::r_trim
	    - ::l_trim
	    - ::trim
	    - ::strtrok_single_char
\***************************************************************************/


#ifndef dSTRING_ADDON_H

#define   dSTRING_ADDON_H /**< precompiler help */
/* Defines for Code-Control
 ****************************************************************************/

/* Includes
****************************************************************************/
	#include <stdio.h>


/* Defines
****************************************************************************/
	/* ASCII - CHARACTERS */
	#define dASCII_BEL				0x07	/**< "Bell"				*/
	#define dASCII_BS				0x08	/**< Back Space 		*/
	#define dASCII_CR				0x0D	/**< Carriage Return 	*/
	#define dASCII_LF				0x0A	/**< Line Feed 			*/
	#define dASCII_ESC				0x1B	/**< Escape				*/
	#define dASCII_DEL				0x7F	/**< Delete				*/
	#define dASCII_SPACE			0x20	/**< Space				*/
	#define dASCII_COMMA			0x2C	/**< Comma				*/

	/* Formating chararcters */
	#define _STRING_EOS				0x00	/**< End of String */

/* Macros
****************************************************************************/

/* Type definitions
****************************************************************************/

/* ENUM
****************************************************************************/

/* Prototypes
****************************************************************************/
	void r_trim(char *string, char sign);
	void l_trim(char *string, char sign);
	void trim(char *string[], char sign);
	char *strtrok_single_char(char *c_ptr_search, char c_search);


#endif
